Redmine - Feature #4221

Force passwords to contain specified character classes
2009-11-16 10:08 - jim joseph

Status: Closed Start date: 2009-11-16
Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Accounts / authentication Estimated time: 0.00 hour
Target version: 4.1.0

Resolution: Fixed

Description

I would like to enforce strong password for users in redmine. As if now redmine will accept any four letter password. Is there a way

that applicaton checks how strong a password is when a new user register in it.

Can we implement any password generator with redmine?

Related issues:

Related to Redmine - Feature #3872: New user password - better functionality Closed
Related to Redmine - Feature #3155: Password policy and secure logon procedure New

Related to Redmine - Defect #37449: Passing a wrong parameter to “with_settin... Closed
Has duplicate Redmine - Feature #25054: Enforcing Strong Password in Redmine Closed

2009-09-15
2009-04-10

Associated revisions

Revision 18411 - 2019-08-29 03:35 - Go MAEDA

Force passwords to contain specified character classes (#4221).

Patch by Takenori TAKAKI.

Revision 18412 - 2019-08-29 04:15 - Go MAEDA
Update locales (#4221).

Revision 18413 - 2019-08-29 09:15 - Go MAEDA
Update locales (#4221).

Revision 18414 - 2019-08-29 10:46 - Go MAEDA

Send security notifications when password_required_char_classes setting is changed (#4221).

History

#1 - 2009-11-16 19:37 - Jean-Philippe Lang

As of r2678, you can specify the minimum password length in settings.

But a minimum password strength setting could be also added (eg. Fair, Strong, Very strong) using kind of password strengh meter.

#2 - 2009-11-19 20:35 - Jean-Philippe Lang

- Category set to Accounts / authentication

#3 - 2009-11-20 14:17 - Henrik Ammer

Jean-Philippe Lang wrote:

But a minimum password strength setting could be also added (eg. Fair, Strong, Very strong) using kind of password strengh meter.

| would love to see this!

#4 - 2013-07-18 11:28 - Samuel Suther
*1
https://www.redmine.org/projects/redmine/repository/svn/revisions/2678

#5 - 2013-08-01 19:52 - @ go2null

Can we implement any password generator with redmine?

e Implemented in v2.4.0 - Feature #3872 New user password - better functionality

#6 - 2013-08-02 04:18 - Toshi MARUYAMA

- Related to Feature #3872: New user password - better functionality added

#7 - 2014-03-04 08:21 - Simon O

1

The new feature implemented in 2.4.0+ referring to Feature #3872 includes a secured password generator.

However, if users may change their password at first login, they may pick "aaaaaaaa" which is far away from being secure. Thus, | also recommend
to add a kind of password security check as suggested by jim joseph.

Please reopen ticket.

Thanks a lot!

#8 - 2016-01-01 13:01 - Aleksandar Pavic

+1
There are some recent efforts as | can see.

https://github.com/simonswine/redmine_password_tool
https://github.com/go2null/redmine_account_policy

But this should be a core system feature, it is a must for enterprise use.

#9 - 2017-02-12 15:14 - Toshi MARUYAMA
- Has duplicate Feature #25054: Enforcing Strong Password in Redmine added

#10 - 2019-04-24 04:19 - Go MAEDA

- Related to Feature #3155: Password policy and secure logon procedure added

#11 - 2019-08-02 09:19 - Takenori TAKAKI

- File enforce-password-char-types.patch added

+
If we can enforce password strength, Redmine will be used in environments where some security policy is required.
| post a patch, as | implemented the following features:

e Enable to setting password strength in admin settings
¢ Enable to selecting the enforce character types (Uppercase, Lowercase, Digits, Special characters).
¢ Validation for each enforce character types

#12 - 2019-08-07 05:15 - Go MAEDA
- Priority changed from High to Normal

- Target version set to Candidate for next major release

#13 - 2019-08-07 05:53 - Go MAEDA

| think the validation in enforce-password-char-types.patch should cover all ASCII special characters, such as '(', '), '+, '-', and '_'". The following code
does that.

diff --git a/app/models/setting.rb b/app/models/setting.rb
index b18f8ed89..4171fal4e 100644

-—— a/app/models/setting.rb

+++ b/app/models/setting.rb

@@ -19,6 +19,13 @@

class Setting < ActiveRecord: :Base
+ PASSWORD_REQUIRED_CHARACTER_CLASSES = {

+ 'uppercase' => /[A-Z]/,
+ 'lowercase' => /la-z]/,
http://www.redmine.org/versions/70
https://www.redmine.org/issues/3872
https://www.redmine.org/issues/3872
https://github.com/simonswine/redmine_password_tool
https://github.com/go2null/redmine_account_policy
https://www.redmine.org/attachments/23568

'digits' => /[0-91/,
'special_characters' => /[[:ascii:]&&[:graph:]&&[:”alnum:]]/

}

+ + + +

#14 - 2019-08-27 09:38 - Takenori TAKAKI

- File enforce-password-char-types-v2.patch added

Thank you Mr. Maeda.
| change a patch and post it again.

Changed definition of 'special_characters' to the code proposed by Mr. Maeda

Changed regular expression in validation of special characters. => Almost all special characters within the ASCII range can be used.
Shortened constant and label names.

On password generation, contain special characters only when special characters are required.

Added display of usable characters such as "Change Password" Form.

#15 - 2019-08-27 11:49 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0
LGTM. Setting the target version to 4.1.0.

#16 - 2019-08-28 05:58 - Go MAEDA

- File setting-required-character-classes-for-passwords@2x.png added

This is the screenshot of enforce-password-char-types-v2.patch. Admins can force users to include specified character classes (uppercase,
lowercase, digits, or special Characters) in their password. This feature must be welcomed by many admins.

Settings

Authentication

Authentication required No, allow anonymous access to public projects

When not requiring authentication, public projects and their contents are openl
the applicable permissions.

Autologin disabled
Self-registration manual account activation
Show custom fields on registration

Minimum password length | 8

Required character classes for passwords Uppercase Lowercase Digits Special characters

Require password change after disabled
Allow password reset via email

Allow OpenlD login and registration

#17 - 2019-08-29 03:35 - Go MAEDA

- Subject changed from Enforcing Strong Password for Users to Force passwords to contain specified character classes
- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for improving Redmine.
https://www.redmine.org/attachments/23710

#19 - 2022-07-16 07:34 - Go MAEDA

- Related to Defect #37449: Passing a wrong parameter to "with_settings" in UserTest::test_random_password_include_required_characters added

Files

enforce-password-char-types.patch 7.98 KB 2019-08-02 Takenori TAKAKI
enforce-password-char-types-v2.patch 11 KB 2019-08-27 Takenori TAKAKI
setting-required-character-classes-for-passwords@2x.png 48.4 KB 2019-08-28 Go MAEDA
